import React, { PropTypes } from 'react';
import { connect } from 'react-redux';
import selectn from 'selectn';

import actionName from '../../utils/actionName';

import textboxChange from './redux-actions/textboxChange';


const changeType = actionName('CHANGE');

export {
    changeType
};

export default ({
    Component
} ={}) => {

    const Container = React.createClass({

        displayName: `${Component.displayName}Container`,

        propTypes: {
            actionTypePrefix: PropTypes.string.isRequired,
            path: PropTypes.string.isRequired,
            root: PropTypes.string.isRequired
        },

        render() {
            return (
                <Component { ...this.props } />
            );
        }

    });

    const mapStateToProps = (state, props) => {
        return {
            value: selectn(`${props.root}.${props.path}.rawValue`, state.components)
        };
    };

    const mapDispatchToProps = (dispatch, props) => {
        const { actionTypePrefix, path, root } = props;
        return {
            onChange: ({ rawValue, value }) => dispatch(textboxChange({ path, rawValue, root, type: changeType(actionTypePrefix), value }))
        };
    };

    return connect(mapStateToProps, mapDispatchToProps)(Container);

};
