import Immutable from 'seamless-immutable';
import { combineReducers, createStore } from 'redux';

import foundationReducers from '../reducers';


export default (defaultComponentState = []) => {
    const root = combineReducers({
        actions: (state = Immutable([]), action = {}) => {
            if (action.type === '@@redux/INIT') {
                return state;
            }

            return [...state, action];
        },
        components: (state = Immutable(defaultComponentState), action = {}) => {
            return foundationReducers(state, action);
        }
    });

    return createStore(root);
};
